Index: frontends/php/include/items.inc.php
===================================================================
--- frontends/php/include/items.inc.php	(revision 38884)
+++ frontends/php/include/items.inc.php	(working copy)
@@ -199,7 +199,7 @@
 //*/
 		$sql='SELECT i.itemid,i.hostid '.
 				' FROM hosts_groups hg,items i '.
-				' WHERE hg.groupid='.$groupid.
+				' WHERE hg.groupid='.zbx_dbstr($groupid).
 					' and i.key_='.zbx_dbstr($item['key_']).
 					' and hg.hostid=i.hostid';
 		$result=DBexecute($sql);
@@ -224,7 +224,7 @@
 		$del_items = array();
 		$sql='SELECT i.itemid '.
 			' FROM hosts_groups hg,items i'.
-			' WHERE hg.groupid='.$groupid.
+			' WHERE hg.groupid='.zbx_dbstr($groupid).
 				' AND i.key_='.zbx_dbstr($item["key_"]).
 				' AND hg.hostid=i.hostid';
 		$result=DBexecute($sql);
@@ -242,7 +242,7 @@
 	function	add_item_to_group($groupid,$item){
 /*	$description,$key,$hostid,$delay,$history,$status,$type,$snmp_community,$snmp_oid,$value_type,$trapper_hosts,$snmp_port,$units,$multiplier,$delta,$snmpv3_securityname,$snmpv3_securitylevel,$snmpv3_authpassphrase,$snmpv3_privpassphrase,$formula,$trends,$logtimefmt,$valuemapid,$delay_flex,$params,$ipmi_sensor,$applications)
 //*/
-		$sql='SELECT hostid FROM hosts_groups WHERE groupid='.$groupid;
+		$sql='SELECT hostid FROM hosts_groups WHERE groupid='.zbx_dbstr($groupid);
 		$result=DBexecute($sql);
 		while($row=DBfetch($result)){
 			$item['hostid'] = $row['hostid'];
@@ -377,7 +377,7 @@
 
 		$sql = 'SELECT itemid,hostid '.
 				' FROM items '.
-				' WHERE hostid='.$item['hostid'].
+				' WHERE hostid='.zbx_dbstr($item['hostid']).
 					' AND key_='.zbx_dbstr($item['key_']);
 		$db_item = DBfetch(DBselect($sql));
 		if($db_item && $item['templateid'] == 0){
@@ -402,15 +402,15 @@
 					'delta,snmpv3_securityname,snmpv3_securitylevel,snmpv3_authpassphrase,'.
 					'snmpv3_privpassphrase,formula,trends,logtimefmt,valuemapid,'.
 					'delay_flex,params,ipmi_sensor,templateid,authtype,username,password,publickey,privatekey)'.
-			' VALUES ('.$itemid.','.zbx_dbstr($item['description']).','.zbx_dbstr($item['key_']).','.$item['hostid'].','.
-						$item['delay'].','.$item['history'].','.$item['status'].','.$item['type'].','.
-						zbx_dbstr($item['snmp_community']).','.zbx_dbstr($item['snmp_oid']).','.$item['value_type'].','.$item['data_type'].','.
-						zbx_dbstr($item['trapper_hosts']).','.$item['snmp_port'].','.zbx_dbstr($item['units']).','.$item['multiplier'].','.
-						$item['delta'].','.zbx_dbstr($item['snmpv3_securityname']).','.$item['snmpv3_securitylevel'].','.
+			' VALUES ('.$itemid.','.zbx_dbstr($item['description']).','.zbx_dbstr($item['key_']).','.zbx_dbstr($item['hostid']).','.
+						$item['delay'].','.zbx_dbstr($item['history']).','.zbx_dbstr($item['status']).','.zbx_dbstr($item['type']).','.
+						zbx_dbstr($item['snmp_community']).','.zbx_dbstr($item['snmp_oid']).','.zbx_dbstr($item['value_type']).','.zbx_dbstr($item['data_type']).','.
+						zbx_dbstr($item['trapper_hosts']).','.zbx_dbstr($item['snmp_port']).','.zbx_dbstr($item['units']).','.zbx_dbstr($item['multiplier']).','.
+						zbx_dbstr($item['delta']).','.zbx_dbstr($item['snmpv3_securityname']).','.zbx_dbstr($item['snmpv3_securitylevel']).','.
 						zbx_dbstr($item['snmpv3_authpassphrase']).','.zbx_dbstr($item['snmpv3_privpassphrase']).','.
-						zbx_dbstr($item['formula']).','.$item['trends'].','.zbx_dbstr($item['logtimefmt']).','.$item['valuemapid'].','.
+						zbx_dbstr($item['formula']).','.zbx_dbstr($item['trends']).','.zbx_dbstr($item['logtimefmt']).','.zbx_dbstr($item['valuemapid']).','.
 						zbx_dbstr($item['delay_flex']).','.zbx_dbstr($item['params']).','.
-						zbx_dbstr($item['ipmi_sensor']).','.$item['templateid'].','.$item['authtype'].','.
+						zbx_dbstr($item['ipmi_sensor']).','.zbx_dbstr($item['templateid']).','.zbx_dbstr($item['authtype']).','.
 						zbx_dbstr($item['username']).','.zbx_dbstr($item['password']).','.
 						zbx_dbstr($item['publickey']).','.zbx_dbstr($item['privatekey']).')'
 			);
@@ -422,7 +422,7 @@
 
 		foreach($item['applications'] as $key => $appid){
 			$itemappid=get_dbid('items_applications','itemappid');
-			DBexecute('INSERT INTO items_applications (itemappid,itemid,applicationid) VALUES('.$itemappid.','.$itemid.','.$appid.')');
+			DBexecute('INSERT INTO items_applications (itemappid,itemid,applicationid) VALUES('.$itemappid.','.zbx_dbstr($itemid).','.zbx_dbstr($appid).')');
 		}
 
 		info(S_ADDED_NEW_ITEM.SPACE.$host['host'].':'.$item['key_']);
@@ -484,11 +484,11 @@
 			if($status != $old_status){
 /*				unset($itemids[$row['itemid']]);*/
 				if ($status==ITEM_STATUS_ACTIVE)
-					$sql='UPDATE items SET status='.$status.",error='' ".
-						' WHERE itemid='.$row['itemid'];
+					$sql='UPDATE items SET status='.zbx_dbstr($status).",error='' ".
+						' WHERE itemid='.zbx_dbstr($row['itemid']);
 				else
-					$sql='UPDATE items SET status='.$status.
-						' WHERE itemid='.$row['itemid'];
+					$sql='UPDATE items SET status='.zbx_dbstr($status).
+						' WHERE itemid='.zbx_dbstr($row['itemid']);
 
 				$result &= DBexecute($sql);
 				if ($result){
@@ -570,14 +570,14 @@
 			$item['data_type'] = 0;
 		}
 
-		$db_item = DBfetch(DBselect('SELECT itemid FROM items WHERE hostid='.$item['hostid'].' and itemid<>'.$itemid.' and key_='.zbx_dbstr($item['key_'])));
+		$db_item = DBfetch(DBselect('SELECT itemid FROM items WHERE hostid='.zbx_dbstr($item['hostid']).' and itemid<>'.zbx_dbstr($itemid).' and key_='.zbx_dbstr($item['key_'])));
 		if($db_item && $item['templateid'] == 0){
 			error(S_AN_ITEM_WITH_THE_KEY.SPACE.'['.$item['key_'].']'.SPACE.S_ALREADY_EXISTS_FOR_HOST_SMALL.SPACE.'['.$host['host'].'].'.SPACE.S_THE_KEY_MUST_BE_UNIQUE);
 			return FALSE;
 		}
 
 // first update child items
-		$db_tmp_items = DBselect('SELECT itemid, hostid FROM items WHERE templateid='.$itemid);
+		$db_tmp_items = DBselect('SELECT itemid, hostid FROM items WHERE templateid='.zbx_dbstr($itemid));
 		while($db_tmp_item = DBfetch($db_tmp_items)){
 			$child_item_params = $item_in_params;
 
@@ -612,14 +612,14 @@
 		}
 
 		$item_old = get_item_by_itemid($itemid);
-		DBexecute('UPDATE items SET lastlogsize=0, mtime=0 WHERE itemid='.$itemid.' AND key_<>'.zbx_dbstr($item['key_']));
+		DBexecute('UPDATE items SET lastlogsize=0, mtime=0 WHERE itemid='.zbx_dbstr($itemid).' AND key_<>'.zbx_dbstr($item['key_']));
 
 
 		if($upd_app){
-			$result = DBexecute('DELETE FROM items_applications WHERE itemid='.$itemid);
+			$result = DBexecute('DELETE FROM items_applications WHERE itemid='.zbx_dbstr($itemid));
 			foreach($item['applications'] as $appid){
 				$itemappid=get_dbid('items_applications','itemappid');
-				DBexecute('INSERT INTO items_applications (itemappid,itemid,applicationid) VALUES ('.$itemappid.','.$itemid.','.$appid.')');
+				DBexecute('INSERT INTO items_applications (itemappid,itemid,applicationid) VALUES ('.$itemappid.','.zbx_dbstr($itemid).','.zbx_dbstr($appid).')');
 			}
 		}
 
@@ -630,37 +630,38 @@
 			'UPDATE items '.
 			' SET description='.zbx_dbstr($item['description']).','.
 				'key_='.zbx_dbstr($item['key_']).','.
-				'hostid='.$item['hostid'].','.
-				'delay='.$item['delay'].','.
-				'history='.$item['history'].','.
-				'type='.$item['type'].','.
+				'hostid='.zbx_dbstr($item['hostid']).','.
+				'delay='.zbx_dbstr($item['delay']).','.
+				'history='.zbx_dbstr($item['history']).','.
+				'type='.zbx_dbstr($item['type']).','.
 				'snmp_community='.zbx_dbstr($item['snmp_community']).','.
 				'snmp_oid='.zbx_dbstr($item['snmp_oid']).','.
-				'value_type='.$item['value_type'].','.
-				'data_type='.$item['data_type'].','.
+				'value_type='.zbx_dbstr($item['value_type']).','.
+				'data_type='.zbx_dbstr($item['data_type']).','.
 				'trapper_hosts='.zbx_dbstr($item['trapper_hosts']).','.
-				'snmp_port='.$item['snmp_port'].','.
+				'snmp_port='.zbx_dbstr($item['snmp_port']).','.
 				'units='.zbx_dbstr($item['units']).','.
-				'multiplier='.$item['multiplier'].','.
-				'delta='.$item['delta'].','.
+				'multiplier='.zbx_dbstr($item['multiplier']).','.
+				'delta='.zbx_dbstr($item['delta']).','.
 				'snmpv3_securityname='.zbx_dbstr($item['snmpv3_securityname']).','.
-				'snmpv3_securitylevel='.$item['snmpv3_securitylevel'].','.
+				'snmpv3_securitylevel='.zbx_dbstr($item['snmpv3_securitylevel']).','.
 				'snmpv3_authpassphrase='.zbx_dbstr($item['snmpv3_authpassphrase']).','.
 				'snmpv3_privpassphrase='.zbx_dbstr($item['snmpv3_privpassphrase']).','.
 				'formula='.zbx_dbstr($item['formula']).','.
-				'trends='.$item['trends'].','.
+				'trends='.zbx_dbstr($item['trends']).','.
 				'logtimefmt='.zbx_dbstr($item['logtimefmt']).','.
-				'valuemapid='.$item['valuemapid'].','.
+				'valuemapid='.zbx_dbstr($item['valuemapid']).','.
 				'delay_flex='.zbx_dbstr($item['delay_flex']).','.
 				'params='.zbx_dbstr($item['params']).','.
 				'ipmi_sensor='.zbx_dbstr($item['ipmi_sensor']).','.
-				'templateid='.$item['templateid'].','.
-				'authtype='.$item['authtype'].','.
+				'templateid='.zbx_dbstr($item['templateid']).','.
+				'authtype='.zbx_dbstr($item['authtype']).','.
 				'username='.zbx_dbstr($item['username']).','.
 				'password='.zbx_dbstr($item['password']).','.
 				'publickey='.zbx_dbstr($item['publickey']).','.
 				'privatekey='.zbx_dbstr($item['privatekey']).
-			' WHERE itemid='.$itemid);
+			' WHERE itemid='.zbx_dbstr($itemid)
+		);
 
 		if ($result){
 			$item_new = get_item_by_itemid($itemid);
@@ -772,7 +773,7 @@
 			}
 
 			if($unlink_mode){
-				if(DBexecute('UPDATE items SET templateid=0 WHERE itemid='.$db_item["itemid"])){
+				if(DBexecute('UPDATE items SET templateid=0 WHERE itemid='.zbx_dbstr($db_item["itemid"]))){
 					info("Item '".$db_item["key_"]."' unlinked");
 				}
 			}
@@ -898,7 +899,7 @@
 	}
 
 	function get_item_by_itemid($itemid){
-		$row = DBfetch(DBselect('select * from items where itemid='.$itemid));
+		$row = DBfetch(DBselect('select * from items where itemid='.zbx_dbstr($itemid)));
 		if($row){
 			return	$row;
 		}
@@ -913,7 +914,7 @@
 					'formula,trends,logtimefmt,valuemapid,delay_flex,params,ipmi_sensor,templateid,'.
 					'authtype,username,password,publickey,privatekey '.
 			' FROM items '.
-			' WHERE itemid='.$itemid;
+			' WHERE itemid='.zbx_dbstr($itemid);
 		$row = DBfetch(DBselect($sql));
 		if($row){
 			return	$row;
@@ -950,7 +951,7 @@
 		if(isset($itemid)){
 			$sql = 'SELECT src.* '.
 							' FROM items src, items dest '.
-							' WHERE dest.itemid='.$itemid.
+							' WHERE dest.itemid='.zbx_dbstr($itemid).
 								' AND src.key_=dest.key_ '.
 								' AND '.DBcondition('src.hostid',$dest_hostids);
 
@@ -1043,7 +1044,7 @@
 
 		foreach ($itemids as $id) {	/* The section should be improved */
 			$item_old = get_item_by_itemid($id);
-			$result = DBexecute('DELETE FROM items WHERE itemid='.$id);
+			$result = DBexecute('DELETE FROM items WHERE itemid='.zbx_dbstr($id));
 			if ($result)
 				add_audit_ext(AUDIT_ACTION_DELETE, AUDIT_RESOURCE_ITEM, $id, $item_old['description'], 'items', NULL, NULL);
 			else
@@ -1318,7 +1319,7 @@
 
 		foreach($applications as $appid){
 			$db_apps = DBselect("select a1.applicationid from applications a1, applications a2".
-					" where a1.name=a2.name and a1.hostid=".$hostid." and a2.applicationid=".$appid);
+					" where a1.name=a2.name and a1.hostid=".zbx_dbstr($hostid)." and a2.applicationid=".zbx_dbstr($appid));
 			$db_app = DBfetch($db_apps);
 			if(!$db_app) continue;
 			array_push($child_applications,$db_app["applicationid"]);
@@ -1361,27 +1362,27 @@
 			foreach($itemids as $id => $itemid){
 				$housekeeperid = get_dbid('housekeeper','housekeeperid');
 				$sql = 'INSERT INTO housekeeper (housekeeperid,tablename,field,value)'.
-							" VALUES ($housekeeperid,'history_text','itemid',$itemid)";
+							" VALUES ($housekeeperid,'history_text','itemid',".zbx_dbstr($itemid).")";
 				DBexecute($sql);
 
 				$housekeeperid = get_dbid('housekeeper','housekeeperid');
 				$sql = 'INSERT INTO housekeeper (housekeeperid,tablename,field,value)'.
-							" VALUES ($housekeeperid,'history_log','itemid',$itemid)";
+							" VALUES ($housekeeperid,'history_log','itemid',".zbx_dbstr($itemid).")";
 				DBexecute($sql);
 
 				$housekeeperid = get_dbid('housekeeper','housekeeperid');
 				$sql = 'INSERT INTO housekeeper (housekeeperid,tablename,field,value)'.
-							" VALUES ($housekeeperid,'history_uint','itemid',$itemid)";
+							" VALUES ($housekeeperid,'history_uint','itemid',".zbx_dbstr($itemid).")";
 				DBexecute($sql);
 
 				$housekeeperid = get_dbid('housekeeper','housekeeperid');
 				$sql = 'INSERT INTO housekeeper (housekeeperid,tablename,field,value)'.
-							" VALUES ($housekeeperid,'history_str','itemid',$itemid)";
+							" VALUES ($housekeeperid,'history_str','itemid',".zbx_dbstr($itemid).")";
 				DBexecute($sql);
 
 				$housekeeperid = get_dbid('housekeeper','housekeeperid');
 				$sql = 'INSERT INTO housekeeper (housekeeperid,tablename,field,value)'.
-							" VALUES ($housekeeperid,'history','itemid',$itemid)";
+							" VALUES ($housekeeperid,'history','itemid',".zbx_dbstr($itemid).")";
 				DBexecute($sql);
 			}
 			return TRUE;
@@ -1407,7 +1408,7 @@
 			foreach($itemids as $id => $itemid){
 				$housekeeperid = get_dbid('housekeeper','housekeeperid');
 				DBexecute('INSERT INTO housekeeper (housekeeperid,tablename,field,value)'.
-					" VALUES ($housekeeperid, 'trends','itemid',$itemid)");
+					" VALUES ($housekeeperid, 'trends','itemid',".zbx_dbstr($itemid).")");
 			}
 			return TRUE;
 		}
@@ -1482,18 +1483,18 @@
 		}
 
 		if($last == 0){
-			$sql = 'select value from '.$table.' where itemid='.$db_item['itemid'].' and clock<='.$clock.
+			$sql = 'select value from '.$table.' where itemid='.zbx_dbstr($db_item['itemid']).' and clock<='.zbx_dbstr($clock).
 					' order by itemid,clock desc';
 			$row = DBfetch(DBselect($sql, 1));
 			if($row)
 				$value = $row["value"];
 		}
 		else{
-			$sql = "select max(clock) as clock from $table where itemid=".$db_item["itemid"];
+			$sql = "select max(clock) as clock from $table where itemid=".zbx_dbstr($db_item["itemid"]);
 			$row = DBfetch(DBselect($sql));
 			if($row && !is_null($row["clock"])){
 				$clock = $row["clock"];
-				$sql = "select value from $table where itemid=".$db_item["itemid"]." and clock=$clock";
+				$sql = "select value from $table where itemid=".zbx_dbstr($db_item["itemid"]).' and clock='.zbx_dbstr($clock);
 				$row = DBfetch(DBselect($sql, 1));
 				if($row)
 					$value = $row["value"];
Index: frontends/php/include/acknow.inc.php
===================================================================
--- frontends/php/include/acknow.inc.php	(revision 38884)
+++ frontends/php/include/acknow.inc.php	(working copy)
@@ -23,7 +23,7 @@
 function get_last_event_by_triggerid($triggerid){
 	$event_data = DBfetch(DBselect('SELECT * '.
 				' FROM events '.
-				' WHERE objectid='.$triggerid.
+				' WHERE objectid='.zbx_dbstr($triggerid).
 					' and object='.EVENT_OBJECT_TRIGGER.
 				' ORDER BY objectid desc, object desc, eventid desc', 1));
 	if(!$event_data)
@@ -32,7 +32,7 @@
 }
 
 function get_acknowledges_by_eventid($eventid){
-	return DBselect("select * from acknowledges where eventid=$eventid");
+	return DBselect("select * from acknowledges where eventid=".zbx_dbstr($eventid));
 }
 
 function add_acknowledge_coment($eventid, $userid, $message){
@@ -43,7 +43,7 @@
 	$acknowledgeid = get_dbid("acknowledges","acknowledgeid");
 
 	$result =  DBexecute("insert into acknowledges (acknowledgeid,userid,eventid,clock,message)".
-		" values ($acknowledgeid,$userid,$eventid,".time().",".zbx_dbstr($message).")");
+		" values ($acknowledgeid,".zbx_dbstr($userid).",".zbx_dbstr($eventid).",".time().",".zbx_dbstr($message).")");
 
 	if(!$result)
 		return $result;
@@ -52,7 +52,7 @@
 }
 
 function set_event_acnowledged($eventid){
-	return DBexecute("update events set acknowledged=1 where eventid=$eventid");
+	return DBexecute("update events set acknowledged=1 where eventid=".zbx_dbstr($eventid));
 }
 
 function make_acktab_by_eventid($eventid){
